# -*- coding: utf-8 -*-
"""
Created on Thu Dec 19 10:32:22 2024

@author: Sots
"""

import numpy as np
import matplotlib.pyplot as plt

# f(x) = x^2 + 5x + 3 fonksiyonunu ele alalım.
def f(x):
    return x**2 + 5*x + 3

# f'(x) = 2x + 5 türevi
def f_prime(x):
    return 2*x + 5

def numeric_derivative_f(x, h=1e-5):
    return (f(x + h) - f(x - h)) / (2 * h)

# Başlangıç noktası
x = 5.0
öğrenme_oranı = 0.1
iterasyon_sayısı = 20

x_değerleri = [x]
f_değerleri = [f(x)]

for i in range(iterasyon_sayısı):
    grad = f_prime(x)
    x = x - öğrenme_oranı * grad
    x_değerleri.append(x)
    f_değerleri.append(f(x))

# Sonucu yazdır
print("Son x değeri:", x)
print("Son f(x) değeri:", f(x))

# Fonksiyonu görselleştirme
x_aralık = np.linspace(-10, 10, 100)
y_aralık = f(x_aralık)

plt.figure(figsize=(8,6))
plt.plot(x_aralık, y_aralık, label='f(x)')
plt.scatter(x_değerleri, f_değerleri, color='red', label='Iterasyon Noktaları')
plt.xlabel('x')
plt.ylabel('f(x)')
plt.title('Gradient Descent Adımları')
plt.legend()
plt.grid(True)
plt.show()

# 1 / 0

# ------------------

# import numpy as np
# import matplotlib.pyplot as plt

# # f(x, y) = x² + y²
# def f_2d(x, y):
#     return x**2 + y**2

# # Gradyan: df/dx = 2x, df/dy = 2y
# def grad_f_2d(x, y):
#     return np.array([2*x, 2*y])

# # Başlangıç noktası
# xy = np.array([4.0, -3.0])
# öğrenme_oranı = 0.1
# iterasyon_sayısı = 20

# xy_tarihçe = [xy.copy()]

# for i in range(iterasyon_sayısı):
#     grad = grad_f_2d(xy[0], xy[1])
#     xy = xy - öğrenme_oranı * grad
#     xy_tarihçe.append(xy.copy())

# # Sonucu yazdır
# print("Son (x, y) değeri:", xy)
# print("Son f(x, y) değeri:", f_2d(xy[0], xy[1]))

# # Kontur çizimi
# X = np.linspace(-5, 5, 100)
# Y = np.linspace(-5, 5, 100)
# X, Y = np.meshgrid(X, Y)
# Z = f_2d(X, Y)

# plt.figure(figsize=(8,6))
# plt.contour(X, Y, Z, levels=20)
# xy_tarihçe = np.array(xy_tarihçe)
# plt.plot(xy_tarihçe[:,0], xy_tarihçe[:,1], 'ro--', label='Gradient Descent Yolu')
# plt.xlabel('x')
# plt.ylabel('y')
# plt.title('2D Fonksiyon üzerinde Gradient Descent')
# plt.legend()
# plt.grid(True)
# plt.show()

1 / 0

# -------------------------

# import numpy as np
# import matplotlib.pyplot as plt

# # Rasgele veri üretimi (x, y)
# np.random.seed(42)
# X = 2 * np.random.rand(100, 1)
# y = 4 + 3 * X + np.random.randn(100, 1)  # Gerçek model: y = 4 + 3x + gürültü

# # Model: y_pred = w * X + b
# # Hata fonksiyonu (MSE): J(w,b) = 1/N * Σ(y_pred - y)^2

# def predict(X, w, b):
#     return X*w + b

# def mse(X, y, w, b):
#     y_pred = predict(X, w, b)
#     return np.mean((y_pred - y)**2)

# def gradient(X, y, w, b):
#     y_pred = predict(X, w, b)
#     dw = 2 * np.mean((y_pred - y)*X)
#     db = 2 * np.mean(y_pred - y)
#     return dw, db

# # Başlangıç değerleri
# w = 0.0
# b = 0.0
# öğrenme_oranı = 0.1
# iterasyon_sayısı = 100

# mse_değerleri = []

# for i in range(iterasyon_sayısı):
#     dw, db = gradient(X, y, w, b)
#     w -= öğrenme_oranı * dw
#     b -= öğrenme_oranı * db
#     mse_değerleri.append(mse(X, y, w, b))

# print("Bulunan w:", w)
# print("Bulunan b:", b)
# print("Son MSE:", mse_değerleri[-1])

# # Veri ve öğrenilen doğruyu görselleştirme
# plt.figure(figsize=(8,6))
# plt.scatter(X, y, label='Veri')
# plt.plot(X, predict(X, w, b), color='red', label='Regresyon Doğrusu')
# plt.xlabel('X')
# plt.ylabel('y')
# plt.title('Gradient Descent ile Doğrusal Regresyon')
# plt.legend()
# plt.grid(True)
# plt.show()

# # MSE değişimini görselleştirme
# plt.figure(figsize=(8,6))
# plt.plot(mse_değerleri, label='MSE')
# plt.xlabel('İterasyon')
# plt.ylabel('MSE')
# plt.title('MSE Değişimi')
# plt.grid(True)
# plt.show()

# ----------------------------------

# import numpy as np
# import matplotlib.pyplot as plt

# # Fonksiyon
# def f(x):
#     return np.sin(x) + 0.5*x**2

# # Sayısal türev hesaplama
# def numerical_derivative(f, x, h=1e-5):
#     return (f(x+h) - f(x-h)) / (2*h)

# # def numerical_derivative(f, x, h=1e-1):
# #     return np.cos(x) + x

# # Başlangıç noktası
# x = 3.0
# learn_rate = 0.1
# iterations = 50

# x_history = [x]
# f_history = [f(x)]

# for i in range(iterations):
#     grad = numerical_derivative(f, x)
#     x = x - learn_rate * grad
#     x_history.append(x)
#     f_history.append(f(x))

# print("Son x değeri:", x)
# print("Son f(x) değeri:", f(x))

# # Görselleştirme
# x_range = np.linspace(-5, 5, 200)
# y_range = f(x_range)

# plt.figure(figsize=(8,6))
# plt.plot(x_range, y_range, label='f(x)')
# plt.scatter(x_history, f_history, color='red', label='GD adımları')
# plt.xlabel('x')
# plt.ylabel('f(x)')
# plt.title('Gradient Descent (Sayısal Türev) - Tek Boyutlu')
# plt.grid(True)
# plt.legend()
# plt.show()

# ------------------------------------------------

# import numpy as np
# import matplotlib.pyplot as plt

# def f_2d(x, y):
#     return (1 - x)**2 + 100*(y - x**2)**2

# def numerical_gradient_2d(f, xy, h=1e-5):
#     x, y = xy[0], xy[1]
#     # ∂f/∂x
#     dfdx = (f(x+h, y) - f(x-h, y)) / (2*h)
#     # ∂f/∂y
#     dfdy = (f(x, y+h) - f(x, y-h)) / (2*h)
#     return np.array([dfdx, dfdy])

# # Başlangıç noktası
# xy = np.array([-2.0, 2.0])
# learn_rate = 0.001
# iterations = 20000  # Rosenbrock zorlu, biraz daha fazla iterasyon gerekebilir.

# xy_history = [xy.copy()]

# for i in range(iterations):
#     grad = numerical_gradient_2d(f_2d, xy)
#     xy = xy - learn_rate * grad
#     xy_history.append(xy.copy())

# print("Son (x, y) değeri:", xy)
# print("Son f(x, y) değeri:", f_2d(xy[0], xy[1]))

# # Kontur çizimi
# X = np.linspace(-2, 2, 200)
# Y = np.linspace(-1, 3, 200)
# X, Y = np.meshgrid(X, Y)
# Z = f_2d(X, Y)

# plt.figure(figsize=(8,6))
# levels = np.logspace(-1, 3, 20)
# plt.contour(X, Y, Z, levels=levels, norm='log', cmap='jet')
# xy_h = np.array(xy_history)
# plt.plot(xy_h[:,0], xy_h[:,1], 'r.-', label='Gradient Descent Yolu')
# plt.xlabel('x')
# plt.ylabel('y')
# plt.title('Rosenbrock Fonksiyonu üzerinde Gradient Descent (Sayısal Türev)')
# plt.grid(True)
# plt.legend()
# plt.show()


# ------------------------------------------------

# import numpy as np

# # Veri üretimi
# np.random.seed(42)
# X = 2 * np.random.rand(100, 1)
# y = 4 + 3 * X + np.random.randn(100, 1)  # y = 4 + 3x + gürültü

# def predict(X, w, b):
#     return X*w + b

# def mse(X, y, w, b):
#     y_pred = predict(X, w, b)
#     return np.mean((y_pred - y)**2)

# def numerical_gradient_mse(X, y, w, b, h=1e-5):
#     # dw
#     dw = (mse(X, y, w+h, b) - mse(X, y, w-h, b)) / (2*h)
#     # db
#     db = (mse(X, y, w, b+h) - mse(X, y, w, b-h)) / (2*h)
#     return dw, db

# # def numerical_gradient_mse(X, y, w, b):
# #     y_pred = predict(X, w, b)
# #     dw = 2 * np.mean((y_pred - y)*X)
# #     db = 2 * np.mean(y_pred - y)
# #     return dw, db

# w = 0.0
# b = 0.0
# learn_rate = 0.1
# iterations = 100

# mse_values = []

# for i in range(iterations):
#     dw, db = numerical_gradient_mse(X, y, w, b)
#     w -= learn_rate * dw
#     b -= learn_rate * db
#     mse_values.append(mse(X, y, w, b))

# print("Bulunan w:", w)
# print("Bulunan b:", b)
# print("Son MSE:", mse_values[-1])

